package simple.dcsp.abtfamily.abt;

import kernel.AbstractAgent;
import kernel.StopException;
import kernel.com.Message;
import kernel.com.MessageHandler;
import simple.Nogood;
import simple.SimpleAgent;
import util.Commands;

/**
 * for each value we store just one Nogood following this heuristic: when comparing two nogoods, select the one with the highest possible lowest
 * variable involved (Nogood Selector HPLV)
 */

public class NogoodsHandler extends MessageHandler {

	public NogoodsHandler(AbstractAgent agent) {
		super(agent, Commands.NOGOOD);
	}

	/**
	 * 
	 */
	public void processMessage(Message msg) throws StopException {
//		if (this.myAgent instanceof ABTHybAgent && !((ABTHybAgent) this.myAgent).var.isInstantiated()){
//			return;
//		}
		Nogood nogood = (Nogood) msg.get(Commands.NOGOOD);
		int myValue = ((SimpleAgent) this.myAgent).var.getValue();
		if (this.isCoherent(nogood)) {
			((ABTAgent) this.myAgent).checkAddLink(nogood);
			((ABTAgent) this.myAgent).makeNoGoodConstraint(nogood);
			((ABTAgent) this.myAgent).checkAgentView();
		} else {// re-send OK message
			this.myAgent.auxiliaryStatistics.get(Commands.nbObsoleteNogood).value++;
			if (nogood.getRhsValue() == myValue) {
				((ABTAgent) this.myAgent).okMsgH.sendOkMessage(msg.getSenderId());
			}
		}
	}

	/**
	 * @param ng
	 */
	public void sendNogood(Nogood ng) {
		Message msg = this.createMessage();
		msg.addContents(Commands.NOGOOD, ng);
		msg.setReceiverId(ng.getRhsAgentId());
		((ABTAgent) this.myAgent).storeStatisticsFor(msg);
		this.myAgent.sendMessage(msg);
	}

	/**
	 * @param nogood
	 */
	public boolean isCoherent(Nogood nogood) {
		int myVal = ((ABTAgent) this.myAgent).var.getValue();
		return this.myAgent.agentView.compatibleWith(nogood.getLhs()) && nogood.getRhsValue() == myVal;
	}

}
