package simple.dcsp.afcfamily.afc.estimDom;

import java.util.HashMap;

import kernel.AbstractAgent;
import kernel.com.Message;
import kernel.order.AgentComplexity;
import simple.dcsp.afcfamily.afc.AFCMaster;
import util.Commands;
import util.IntArray;

public class AFCEstimatedMaster extends AFCMaster {

	private short type = MinDom;
	public static final short MinDom = 1;
	public static final short DomDeg = 2;

	public AFCEstimatedMaster(short type) {
		super(true);
		this.type = type;
	}

	@Override
	public AbstractAgent makeAgent(int agId, String name, String description) {
		return new AFCEstimatedAgent(agId, name, description, this.type);
	}

	public void broadcast(Message msg, int agentId) {
		if (msg.getType().equals(Commands.AO)) {
			HashMap<Integer, AgentComplexity> ac = this.centralizedAO.getAgentsComplexity();
			IntArray ao = (IntArray) msg.get(Commands.ORDER);
			for (int id : ao) {
				msg.addContents(id + "", new Integer(ac.get(id).getMaxDomain()));
			}
		}
		super.broadcast(msg, agentId);
	}

}
