package util;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class Logger {

	private PrintWriter nLog = null;

	private String name;

	private boolean active = false;

	public static boolean LOG_DEBUG = false;

	public static int log_debug_level = 2;
	/**
	 * ERROR_LEVEL = 0
	 */
	public static int ERROR_LEVEL = 0;
	/**
	 * INFO_LEVEL = 1;
	 */
	public static int INFO_LEVEL = 4;
	/**
	 * LEVEL_TRACE_MESSAGE = 2;
	 */
	public static int LEVEL_TRACE_MESSAGE = 2;
	/**
	 * FINE_LEVEL = 3;
	 */
	public static int FINE_LEVEL = 3;
	/**
	 * LEVEL_TRACE_FUNCTION_1 = 4;
	 */
	public static int LEVEL_TRACE_FUNCTION_1 = 4;
	/**
	 * LEVEL_TRACE_FUNCTION_2 = 5;
	 */
	public static int LEVEL_TRACE_FUNCTION_2 = 5;
	/**
	 * DEFAULT_LEVEL = 3;
	 */
	public static int DEFAULT_LEVEL = 3;

	public Logger(String fname) {
		this.name = fname + ".txt";
		String path = "."+File.separator ;
		try {
			File f = new File(path + "logs");
			if (!f.exists()) { f.mkdir(); }
		} catch (Exception e) { e.printStackTrace(); }
		try {
			Runtime.getRuntime().exec("del " + path + "logs" + File.separator + fname);
			Runtime.getRuntime().exec("rm " + path + "logs" + File.separator + fname);
		} catch (Exception e) {}
		try {
			FileWriter ffile = new FileWriter(path + "logs" + File.separator + fname);
			PrintWriter pwtr = new PrintWriter(ffile);
			this.nLog = pwtr;
		} catch (IOException e) {
			System.err.println("Error opening " + path + "logs" + File.separator + fname);
		}
	}

	/**
	 * 
	 * @param directory
	 * @param fname
	 */
	public Logger(String directory, String fname) {
		this.name = fname;
		log_debug_level = DEFAULT_LEVEL;
		String path = directory;
		if (!path.endsWith(File.separator)) {
			path += File.separator ;
		}
		try {
			File f = new File(path);
			if (!f.exists()) {
				f.mkdir();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		try {
			FileWriter ffile = new FileWriter(path + File.separator + fname, false);
			PrintWriter pwtr = new PrintWriter(ffile, true);
			nLog = pwtr;
		} catch (IOException ee) {
			System.err.println(path + File.separator + fname);
			ee.printStackTrace();
		}
	}

	public synchronized void printToLog(String s, int level) {
		if (level >= log_debug_level) {
			this.nLog.print(s);
			this.nLog.flush();
			System.out.print(s);
		}
	}

	public synchronized void printToLog(String s) {
		printToLog(s, DEFAULT_LEVEL);
	}

	public synchronized void printToLogln(String s) {
		printToLogln(s, DEFAULT_LEVEL);
	}

	public synchronized void printToLogln(String s, int level) {
		if (level <= log_debug_level) {
			this.nLog.println(s);
			this.nLog.flush();
			System.out.println(s);
		}
	}

	public void activate() {
		this.active = true;
	}

	public boolean isActivated() {
		return (this.active || LOG_DEBUG);
	}

	public void close() {
		this.nLog.close();
	}

	public String getFileName() {
		return this.name;
	}

	public PrintWriter getPrintWriter() {
		return this.nLog;
	}

}
